////////////////////////////////////////////////////////////////////////////
///Explosion code by Snake67 - The "BoomMaster"
/////////////////////////////////////////////////////////////////
bmap	smokepart_map, <moresmoke.pcx>;
bmap	explosion_map, <fireball.pcx>;
bmap	blacksmoke_map, <smoke.tga>;
sound	explosion_sound, <explode.wav>;
string wgibit_mdl = <wgibit.mdl>;
string cannon_dead_mdl = <cannon_dead.mdl>;

/////////////////////////////////////////////////////////////////
define	speed_x=skill1;
define	speed_y=skill2;
define	speed_z=skill3;

function gibitsmoke_fade()
{
	my.alpha-=time*0.8;
	my.size+=(time/2);
	if(my.alpha<=0) {my.lifespan=0;}
}

function effect_gibitsmoke()
{
	my.alpha=30+random(20);
	my.x+=random(20)-10;
	my.y+=random(20)-10;
	my.z+=random(20)-10;
	my.vel_x=random(2)-1;
	my.vel_y=random(2)-1;
	my.vel_z=random(4)+2;
	my.flare=on;
	my.transparent=on;
	my.move=on;
	my.bright=on;
	my.bmap=smokepart_map;
	my.size=random(8)+8;
	my.function=gibitsmoke_fade;
}



function explosion_gibit_event()
{
	if(event_type==event_block)
	{
		result=vec_to_angle(temp.pan, my.speed_x);
		result/=25;
		vec_scale(bounce.x, result);
		vec_set(my.speed_x, bounce.x);
		vec_set(temp.x, my.x);
		temp.z+=10;
		emit(8, temp.x, particle_scatter);
	}
}

function explosion_gibit()
{
	my.push=-1;
	my.narrow=on;
	my.bright=on;
	my.nofog=on;
	my.ambient=100;
	my.enable_block=on;
	my.event=explosion_gibit_event;
	my.speed_x=random(12)-6;
	my.speed_y=random(12)-6;
	my.speed_z=random(2)+12;
	temp=random(1)+0.7;
	vec_scale(my.scale_x, temp);
	while(1)
	{
		move_mode=ignore_models;
		result=ent_move(my.speed_x, nullvector);
		if(result<=0) {break;}
		my.speed_z-=time*2;
		if(random(10)<1) {effect(effect_gibitsmoke, 1, my.x, nullvector);}
		wait(1);
	}
	my.bright=off;
	my.event=null;
	while(my.ambient>-10)
	{
		my.ambient-=time*2;
		wait(1);
	}
	vec_set(temp.x, my.x);
	temp.z+=10;
	emit(8, temp.x, particle_scatter);
	effect(effect_gibitsmoke, 3, my.x, nullvector);
	waitt(8);
	my.skin=2;
	my.ambient=-50;
	waitt(64);
	my.transparent=on;
	my.alpha=100;
	while(my.alpha>0)
	{
		my.alpha-=time;
		wait(1);
	}
	remove(me);
}

function blacksmoke_fade()
{
	my.alpha-=(time/4);
	if(my.vel_z>3) {my.vel_z-=(time/2);}
	my.size+=time*4;
	if(my.alpha<=0) {my.lifespan=0;}
}

function effect_blacksmoke()
{
	my.alpha=10+random(10);
	my.x+=random(20)-10;
	my.y+=random(20)-10;
	my.z+=random(20)-10;
	my.vel_x=random(4)-2;
	my.vel_y=random(4)-2;
	my.vel_z=random(8)+16;
	my.flare=on;
	my.transparent=on;
	my.move=on;
	my.bmap=blacksmoke_map;
	my.size=random(20)+20;
	my.function=blacksmoke_fade;
}



function explode_fade()
{
	my.alpha-=time;
	my.size+=time*4;
	if(my.alpha<=0) {my.lifespan=0;}
}

function effect_explode()
{
	my.alpha=30+random(20);
	my.x+=random(20)-10;
	my.y+=random(20)-10;
	my.z+=random(20)-10;
	my.vel_x=random(4)-2;
	my.vel_y=random(4)-2;
	my.vel_z=random(6)-1;
	my.flare=on;
	my.move=on;
	my.bright=on;
	my.bmap=explosion_map;
	my.size=random(20)+20;
	my.function=explode_fade;
}

function barrel_event()
{
	if(event_type==event_shoot)||(MY.ENABLE_TRIGGER == ON)
	{
 	my._health-=damage;
  if(my._health>1) {return;}
		my.event=null;
 	morph(<explosion.mdl>, me);
		temp=(random(1)+1)/10;
		vec_scale(my.scale_x, temp);
		my.z+=20;
		my.passable=on;
		my.transparent=on;
		my.alpha=80;
		my.bright=on;
		my.nofog=on;
		my.unlit=on;
		my.ambient=100;
		my.red=255;
		my.green=100;
		my.lightrange=500;
		effect(effect_explode, 10, my.x, nullvector);
		effect(effect_blacksmoke, 10, my.x, nullvector);
		my.skill1=random(2)+4;
//		while(my.skill1>0)
//		{
//			ent_create(wgibit_mdl, my.x, explosion_gibit);
//			my.skill1-=1;
//		}
		while(my.alpha>0)
		{
			my.scale_x+=time*3;
			my.scale_y=my.scale_x;
			my.scale_z=my.scale_x;
			my.alpha-=time*20;
			my.lightrange-=time*20;
			wait(1); 
		}
		play_entsound(me, explosion_sound, 200);
		while(my.lightrange>30)
		{
			my.lightrange-=time*20;
			wait(1);
		}
		remove(me);
	}
}



action gun_powder
{
   my._health=20;
   my.enable_shoot=on;
   my.enable_scan=off;
   my.event=barrel_event;
}

 ACTION hit_grenade
{
MY.ENABLE_impact = ON;
MY.EVENT = barrel_event;
}

ACTION detect_grenade
{
MY.ENABLE_TRIGGER = ON;
MY.TRIGGER_RANGE =150;
MY.EVENT = barrel_event;
}


/////////////////////////////////////////////////////////////////
// End ExDemo
